"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
order.proto

Functions and messages supporting an e-commerce
workflow for things like invoices, shipping labels,
etc.
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import kerfed.protos.common.v1.address_pb2
import kerfed.protos.common.v1.config_pb2
import kerfed.protos.common.v1.fab_pb2
import kerfed.protos.common.v1.fileblob_pb2
import kerfed.protos.common.v1.money_pb2
import kerfed.protos.common.v1.price_pb2
import kerfed.protos.common.v1.scene_pb2
import kerfed.protos.common.v1.shipping_pb2
import sys

if sys.version_info >= (3, 8):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing_extensions.final
class Order(google.protobuf.message.Message):
    """The data structure that represents both an editable "quote," and
    a frozen "placed order."
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ORDER_ID_FIELD_NUMBER: builtins.int
    USER_ID_FIELD_NUMBER: builtins.int
    SHOP_ID_FIELD_NUMBER: builtins.int
    PARTS_FIELD_NUMBER: builtins.int
    CONFIG_FIELD_NUMBER: builtins.int
    PRICES_FIELD_NUMBER: builtins.int
    MODELS_FIELD_NUMBER: builtins.int
    ORIGINALS_FIELD_NUMBER: builtins.int
    SHIPPING_FIELD_NUMBER: builtins.int
    BILLING_FIELD_NUMBER: builtins.int
    PARCELS_FIELD_NUMBER: builtins.int
    TOTAL_FIELD_NUMBER: builtins.int
    order_id: builtins.str
    """the uuid with hyphens"""
    user_id: builtins.str
    """the user placing the order"""
    shop_id: builtins.str
    """the id of the shop this order is associated with."""
    @property
    def parts(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.fab_pb2.PartFabrication]:
        """Analyzed parts."""
    @property
    def config(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.config_pb2.PartConfiguration]:
        """Configurations including quantity."""
    @property
    def prices(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.price_pb2.LinePrice]:
        """Prices for each configuration of the parts"""
    @property
    def models(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.scene_pb2.Scene]:
        """The models for the source files of the parts."""
    @property
    def originals(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.fileblob_pb2.FileBlob]:
        """The original CAD files for the order"""
    @property
    def shipping(self) -> kerfed.protos.common.v1.address_pb2.PostalAddress:
        """where is order shipped to"""
    @property
    def billing(self) -> kerfed.protos.common.v1.address_pb2.PostalAddress:
        """where is order billed to"""
    @property
    def parcels(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.shipping_pb2.ShippingParcel]:
        """the parcels this order is shipping with"""
    @property
    def total(self) -> kerfed.protos.common.v1.price_pb2.OrderPrice:
        """The total price including shipping."""
    def __init__(
        self,
        *,
        order_id: builtins.str = ...,
        user_id: builtins.str = ...,
        shop_id: builtins.str = ...,
        parts: collections.abc.Iterable[kerfed.protos.common.v1.fab_pb2.PartFabrication] | None = ...,
        config: collections.abc.Iterable[kerfed.protos.common.v1.config_pb2.PartConfiguration] | None = ...,
        prices: collections.abc.Iterable[kerfed.protos.common.v1.price_pb2.LinePrice] | None = ...,
        models: collections.abc.Iterable[kerfed.protos.common.v1.scene_pb2.Scene] | None = ...,
        originals: collections.abc.Iterable[kerfed.protos.common.v1.fileblob_pb2.FileBlob] | None = ...,
        shipping: kerfed.protos.common.v1.address_pb2.PostalAddress | None = ...,
        billing: kerfed.protos.common.v1.address_pb2.PostalAddress | None = ...,
        parcels: collections.abc.Iterable[kerfed.protos.common.v1.shipping_pb2.ShippingParcel] | None = ...,
        total: kerfed.protos.common.v1.price_pb2.OrderPrice | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["billing", b"billing", "shipping", b"shipping", "total", b"total"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["billing", b"billing", "config", b"config", "models", b"models", "order_id", b"order_id", "originals", b"originals", "parcels", b"parcels", "parts", b"parts", "prices", b"prices", "shipping", b"shipping", "shop_id", b"shop_id", "total", b"total", "user_id", b"user_id"]) -> None: ...

global___Order = Order

@typing_extensions.final
class Job(google.protobuf.message.Message):
    """a Job is a released-to-manufacture package"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SHOP_ID_FIELD_NUMBER: builtins.int
    ORDER_ID_FIELD_NUMBER: builtins.int
    JOB_ID_FIELD_NUMBER: builtins.int
    PART_ID_FIELD_NUMBER: builtins.int
    AMOUNT_FIELD_NUMBER: builtins.int
    SUMMARY_FIELD_NUMBER: builtins.int
    FILES_FIELD_NUMBER: builtins.int
    PARCELS_FIELD_NUMBER: builtins.int
    shop_id: builtins.str
    """which shop is making this"""
    order_id: builtins.str
    """which order was this job created from"""
    job_id: builtins.str
    """unique identifier for this job"""
    @property
    def part_id(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """the parts being manufactured by this job"""
    @property
    def amount(self) -> kerfed.protos.common.v1.money_pb2.Money:
        """the total amount of money that
        will be disbursed to the shop on completion
        shipping which will be either paid by us or
        invoiced separately.
        """
    @property
    def summary(self) -> kerfed.protos.common.v1.fileblob_pb2.FileBlob:
        """A PDF document with quantities, drawings
        shipping labels, etc.
        """
    @property
    def files(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.fileblob_pb2.FileBlob]:
        """any additional reference files, including
        flattened DXF drawings, original models, etc.
        """
    @property
    def parcels(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.shipping_pb2.ShippingParcel]:
        """the parcels this order is shipping with"""
    def __init__(
        self,
        *,
        shop_id: builtins.str = ...,
        order_id: builtins.str = ...,
        job_id: builtins.str = ...,
        part_id: collections.abc.Iterable[builtins.str] | None = ...,
        amount: kerfed.protos.common.v1.money_pb2.Money | None = ...,
        summary: kerfed.protos.common.v1.fileblob_pb2.FileBlob | None = ...,
        files: collections.abc.Iterable[kerfed.protos.common.v1.fileblob_pb2.FileBlob] | None = ...,
        parcels: collections.abc.Iterable[kerfed.protos.common.v1.shipping_pb2.ShippingParcel] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["amount", b"amount", "summary", b"summary"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["amount", b"amount", "files", b"files", "job_id", b"job_id", "order_id", b"order_id", "parcels", b"parcels", "part_id", b"part_id", "shop_id", b"shop_id", "summary", b"summary"]) -> None: ...

global___Job = Job
